#ifndef _DEPEND_
#define _DEPEND_

#ifndef _TYPES_
#include "types.h"
#endif

#ifndef _SYSTEM_
#include "system.h"
#endif

#ifndef _NODES_
#include "nodes.h"
#endif

/********************************************************************************
 *																				*
 *		bounds (used for evt. copying code on-chip)								*
 *																				*
 ********************************************************************************/

extern LABEL copy__routine__end;
extern LABEL restore__routine__end;

/********************************************************************************
 *																				*
 *		bounds for initial boot routine											*
 *																				*
 ********************************************************************************/

extern LABEL pre__booter;

/********************************************************************************
 *																				*
 *		routine to call debugger												*
 *																				*
 ********************************************************************************/

extern VOID Break(VOID);

/********************************************************************************
 *																				*
 *		basic copying routines													*
 *																				*
 ********************************************************************************/

extern WORD CopyCollect				(VOID);

extern WORD NewGlobalAddress		(VOID *object,UWORD ref);

extern NODE *CopyGraph				(NODE *root);
extern VOID RestoreLocalGraph		(VOID);
extern BOOL RestoreGlobalGraph		(VOID);
extern VOID AdjustPointers			(NODE *start,NODE *end,NODE *original_start);

/********************************************************************************
 *																				*
 *		special low-level routines (too big for macro def, see also				*
 *		hardware.h)																*
 *																				*
 ********************************************************************************/
 
/*	a routine to put a processes at the 'start' of the low prio scheduling list,
	i.e. AFTER the currently interrupted one. These are used by the runtime system
	when processes should wait until some consistent state is produced by some
	interrupted reducer. */
	
extern VOID runp1					(WSP *wsp);
extern VOID low1					(VOID);

extern LABEL start__process;

/********************************************************************************
 *																				*
 *		debugger code															*
 *																				*
 ********************************************************************************/

extern LABEL DebugProcess;		/* process start						*/
extern LABEL DebugProcess2;		/* saved Areg							*/
extern LABEL DebugProcess3;		/* saved Areg, loaded ptr to save area	*/
extern LABEL DebugProcess4;		/* saved Areg and workspace				*/

/********************************************************************************
 *																				*
 *			OCCAM Linkage...													*
 *																				*
 *		declare all these routine with OCCAM linkage: they don't need			*
 *		hidden arguments														*
 *																				*
 ********************************************************************************/

#pragma PACT linkage occam CopyCollect
#pragma PACT linkage occam NewGlobalAddress
#pragma PACT linkage occam CopyGraph
#pragma PACT linkage occam RestoreLocalGraph
#pragma PACT linkage occam RestoreGlobalGraph
#pragma PACT linkage occam AdjustPointers

#pragma PACT linkage occam runp1
#pragma PACT linkage occam low1

#endif