#ifndef _ERROR_NO_
#define _ERROR_NO_

typedef enum ERROR_NUMBER
{
	ENoErr				=0,		/* special: indicates no error has occured */
	
	EUnknown			=1,		/* for unknown errors */
	
	/* start-up errors */
	
	EBoot				=10,	/* for errors during basic start-up */
	EInitInternal		=11,	/* for errors during init int memory */
	EInitExternal		=12,	/* for errors during init ext memory */
	EInitSystem			=13,	/* for errors during basic system init */
	EInitRouter			=14,	/* for errors during init router */
	EInitHeap			=15,	/* for errors during init heap */
	EInitIO				=16,	/* for errors during init io system */
	EInitDebug			=17,	/* for errors during init debugger */
	
	/* errors concerning processes */
	
	ESysProcStart		=20,	/* for errors during startup system procs */
	ERedStart			=21,	/* for errors during startup reducers */
	
	/* errors concerning the heap */
	
	EHeapFull			=30,	/* allocated heap full */
	EHeapInvalid		=31,	/* allocated heap invalid */
	
	/* errors concerning signals */
	
	ESignalUnknown		=40,

	/* errors concerning packets */
	
	EPacketUnavail	=50,
	EPacketInvalid	=51,
	
	/* errors concerning the indirection table */
	
	ETableInval		=60,
	ETableIndex		=61,

	/* bus errors... (on T800 software detection only) */
	
	EBusAddress			=70,	/* general bus error */
	EBusIptr			=71,	/* invalid iptr */
	EBusWsp				=72,	/* invalid wsp */
	EWriteNil			=73,	/* write to 0x00000000 */
	EWriteMint			=74,	/* write to 0x80000000 */
	EReadNil			=75,	/* read from 0x00000000 */
	EReadMint			=76,	/* read from 0x80000000 */
	
	/* global address errors */
	
	EGAddress			=80,	/* for invalid transputer number */
	
	/* arithmetic errors */
	
	EArithmetic		=90,	/* for general arithmetic errors */
	
	/* index errors	*/
	
	EIndexLow			=100,
	EIndexHigh			=101,
	ERangeInval			=102,
	
	/* allocation errors */
	
	EAllocHeap			=110,	/* error during allocation of heap */
	EAllocProgram		=111	/* error during allocation of program */

} ERROR_NUMBER;

#endif