#ifndef _HEAPALLOC_
#define _HEAPALLOC_

#ifndef _SYSTEM_
#include "system.h"
#endif

/********************************************************************************
 *																				*
 *		structure of a block in the heap (pointed to by string node)			*
 *																				*
 ********************************************************************************/

typedef struct VHEAP_BLOCK_ADMIN
{

	WORD	reserved;			/* amount of reserved bytes */
	WORD	initialised;		/* amount of initialised bytes */
	
} VHEAP_BLOCK_ADMIN;

typedef struct VHEAP_BLOCK
{
	VHEAP_BLOCK_ADMIN	admin;
	BYTE				data[VariableArraySize];
	
} VHEAP_BLOCK;

/********************************************************************************
 *																				*
 *		heap initialisation														*
 *																				*
 ********************************************************************************/

extern VOID invalid_heap	(VOID);
extern VOID valid_heap		(VOID);

/********************************************************************************
 *																				*
 *		routines to allocate structures in the heap	(use at high prio)			*
 *		these routines always succeed as they call the garbage collector		*
 *		directly and return AFTER the garbage collection has succeeded			*
 *		Note that this only possible at 'safe' moments, in particular			*
 *		router processes cannot use these routines								*
 *																				*
 ********************************************************************************/

extern VOID	*alloc_words	(WORD n);
extern VOID	*alloc_bytes	(WORD n);
extern WORD	alloc_entry		(VOID);
extern WORD	alloc_reducer	(VOID *code);
extern VOID	alloc_gblock	(WORD id,WORD size);

/********************************************************************************
 *																				*
 *		routines to allocate structures in the heap (use at high prio)			*
 *		these routines deliver NULL (or zero) on failure (after having			*
 *		started the garbage collector)											*
 *																				*
 ********************************************************************************/

extern VOID	*halloc_words	(WORD n);
extern WORD	halloc_reducer	(VOID *code);
extern WORD	halloc_entry	(VOID);
extern BOOL	halloc_gblock	(WORD id,WORD size);

#endif