#ifndef _HOSTIO_
#define _HOSTIO_

#ifndef _TYPES_
#include "types.h"
#endif

#include "packets.h"
#include "io.h"
#include "commands.h"
#include "graphs.h"

#ifdef __INCLUDE_STANDARD__
#include <stdio.h>
#endif

extern VOID host_write_string			(FILE *file,CHAR *string,WORD length);
extern VOID host_write_character		(FILE *file,CHAR *character);
extern VOID host_write_integer			(FILE *file,WORD *integer);
extern VOID host_write_real				(FILE *file,FLOAT *real);
extern VOID host_write_boolean			(FILE *file,BOOL *b);

extern WORD host_read_string			(FILE *file,CHAR *s,WORD length);

extern VOID host_open_file				(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_end_file				(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_output_character		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_input_character		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_input_string			(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_output_string			(WORD kind,WORD source,WORD size,VLONG_FILE_PACKET *packet);
extern VOID host_output_c_string		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_output_c_character		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_output_c_boolean		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_output_c_integer		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_output_c_real			(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_input_c_string			(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_read_command			(WORD kind,WORD source,WORD size,VCOMMAND_PACKET *packet);
extern VOID host_fatal_error			(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_errno					(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_runtime_error			(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_runtime_warning		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_reset_server_clock		(WORD kind,WORD source,WORD size,VFILE_PACKET *packet);
extern VOID host_default_reception		(WORD kind,WORD source,WORD size,VOID *packet);

extern VOID host_handle_reserve			(WORD kind,WORD source,WORD size,ALLOCATION_PACKET *packet);

extern VOID host_close_files			(VOID);
extern BOOL init_hostio					(VOID);

#endif
