#ifndef _IO_
#define _IO_

#ifndef _TYPES_
#include "types.h"
#endif

#ifdef __INCLUDE_STANDARD__
#include <stdarg.h>
#endif

/********************************************************************************
 *																				*
 *		io packets																*
 *																				*
 ********************************************************************************/

typedef struct VFILE_PACKET
{
	WORD	file_number;
	WORD	source_id;
	
	WORD	position;
	BYTE	contents[VariableArraySize];
	
} VFILE_PACKET;

typedef struct VLONG_FILE_PACKET
{
	WORD	file_number;
	WORD	source_id;
	
	WORD	file_position;
	WORD	message_position;
	BYTE	contents[VariableArraySize];

} VLONG_FILE_PACKET;

/********************************************************************************
 *																				*
 *		initialisation routine													*
 *																				*
 ********************************************************************************/

extern BOOL initialise_io(VOID);

/********************************************************************************
 *																				*
 *		synchronous file IO routines											*
 *																				*
 ********************************************************************************/

extern VOID va_file_print		(WORD file_nr, CHAR *string, va_list args);
extern VOID file_print			(WORD file_nr, CHAR *string, ...);
extern VOID print				(CHAR *string, ...);
extern VOID hexit				(WORD n);

extern WORD file_read			(WORD file_nr, CHAR *string);

extern VOID output_string		(WORD destination, WORD file_nr, WORD position, CHAR *string, ...);

/********************************************************************************
 *																				*
 *		debugging/tracing/exceptions/errors										*
 *																				*
 ********************************************************************************/

extern VOID fatal_error			(BOOL sync, CHAR *string, ...);
extern VOID runtime_error		(BOOL sync, CHAR *string, ...);
extern VOID runtime_warning		(BOOL sync, CHAR *string, ...);

extern VOID no_crash			(VOID);
extern VOID tell_error			(BOOL sync, WORD number);
extern VOID tell_action			(BOOL sync, WORD number);

#endif
