
#ifndef _KERNEL_
#define _KERNEL_

#ifndef _TYPES_
#include "types.h"
#endif

/****************************************************************************
 *																			*
 *		signal numbers														*
 *																			*
 ****************************************************************************/

typedef enum SIGNAL_NUMBER
{
										/* 0 not used					*/
	SCollect				=1,			/* perform garbage collection	*/
	SDebugger				=2,			/* call debugger				*/
	SAsyncMessage			=3,			/* insert message from heap		*/
	SSyncMessage			=4,			/* insert message from heap		*/
	SSendGraph				=5,			/* send graph					*/
	SGlobalNode				=6,			/* get global address for node	*/
	SError					=7,			/* signal an error				*/
	SRemovePointer			=8,			/* remove global pointer		*/
	SInitReducer1			=9,			/* initialise a new reducer		*/
	SInitReducer2			=10,		/* initialise off-chip reducer	*/
	SReleaseLocal			=11,		/* release local process		*/
	SProcAtDist				=12,		/* get proc at given distance	*/
	SReleaseRequest			=13,		/* answer remote request		*/
	SCreateChannel			=14,		/* create new channel node		*/
	
	SLastSignal				=14			/* highest signal number		*/
	
} SIGNAL_NUMBER;

/************************************************************************************
 *																					*
 *		(VERY) low level stuff														*
 *																					*
 ************************************************************************************/

#if __CACHE_ROUTINES__

#define save_registers(size)		move(sys_root->save_area,(ADDRESS)sys.reducer_info.on_chip_first_regs,size);
#define restore_registers(size)		move((ADDRESS)sys.reducer_info.on_chip_first_regs,sys_root->save_area,size);

extern LABEL *routine_on_chip (LABEL *routine, WORD size);

#endif

/************************************************************************************
 *																					*
 *		startup of kernel															*
 *																					*
 ************************************************************************************/

extern VOID kernel(VOID);

#endif
