#ifndef _MEMORY_
#define _MEMORY_

#ifndef _SYSTEM_
#include "system.h"
#endif

/********************************************************************************
 *																				*
 *		initial allocation routines												*
 *																				*
 ********************************************************************************/

extern WORD		ext_mem_size(VOID);

extern BOOL		reserve_on_chip_memory	(VOID);
extern BOOL		reserve_off_chip_memory	(VOID);

extern VOID		reset_external_memory	(VOID);

/********************************************************************************
 *																				*
 *		allocation of internal/external memory during system initialisation		*
 *																				*
 ********************************************************************************/

extern VOID		*push_int_mem	(WORD size);
extern VOID		*push_mem		(WORD size);
extern VOID		pop_mem			(WORD size);

extern VOID *push_process(VOID (* func) (), WORD stack_size, WORD npars, ...);

/********************************************************************************
 *																				*
 *		'user' allocation (from other end of memory)							*
 *																				*
 ********************************************************************************/

extern VOID		*user_allocate		(WORD);
extern VOID		user_free_all		(VOID);

#endif
