#ifndef _MESSAGE_NO_
#define _MESSAGE_NO_

#define	ToAll		-2
#define	ToOthers	-1
#define ToHost		0
#define ToRoot		1
#define RootId		1

typedef enum LINK_PROTOCOL_NUMBER
{
	RoutExit		=-4,
	RoutRequest		=-3,
	RoutSignal		=-2,
	RoutCancel		=-1

} LINK_PROTOCOL_NUMBER;

typedef enum MESSAGE_NUMBER
{
	/* loading, execution */
	
	MProgramLoad			=0,			/* command: load program				*/
	MProgramHalt			=1,			/* command: halt program				*/
	MProgramInit			=2,			/* message: program initialised			*/
	MProgramHalted			=3,			/* message: program halted (on 1 proc)	*/
	MProgramReady			=4,			/* message: program executed			*/
	MProgramSegment			=5,			/* data: a code segment					*/

	/* administration */

	MResetClock				=6,			/* command: reset clock					*/
	MDecRef					=7,			/* command: decrement reference count	*/
	MExit					=8,			/* command: exit system					*/

	/* file administration */
	
	MOpenFile				=9,			/* command: open file		*/
	MReopenFile				=10,		/* command: reopen file		*/
	MEndFile				=11,		/* command: 'close' file	*/

	/* message for remote server */
	
	MRemoteServer			=12,		/* message for remote server, forwarded	*/

	/* data transfers */
	
	MOutString				=13,
	MOutCString				=14,
	MInString				=15,
	MInCString				=16,
	
	MOutInteger				=17,
	MOutCInteger			=18,
	MInInteger				=19,
	MInCInteger				=20,
	
	MOutReal				=21,
	MOutCReal				=22,
	MInReal					=23,
	MInCReal				=24,
	
	MOutCharacter			=25,
	MOutCCharacter			=26,
	MInCharacter			=27,
	MInCCharacter			=28,
	
	MOutBoolean				=29,
	MOutCBoolean			=30,
	MInBoolean				=31,
	MInCBoolean				=32,
	
	/* graph transfers */
	
	MOutGraph				=33,
	MOutBlock				=34,
	MInGraph				=36,
	MInBlock				=37,
	MOutBasic				=53,		/* basic node */
	MReserveGraph			=39,		/* only generated by runtime system */
	MReserveBlock			=40,		/* only generated by runtime system */
	
	MInIds					=51,		/* request for ids	*/
	MOutIds					=35,		/* array of ids		*/
	MRequestGraph			=43,
	
	/* command lines */
	
	MInCommand				=44,		/* command: read line */
	MOutCommand				=45,		/* command: execute command */
	MHostCommand			=52,		/* command: forward command to host */

	/* messages */

	MFatalError				=46,
	MRuntimeError			=47,
	MRuntimeWarning			=48,

	MErrno					=49,
	MAction					=50,
	
	MProgramDebugLoad		=51			/* command: load program in debug mode */
	
} MESSAGE_NUMBER;

#endif