#ifndef _ROUTER_
#define _ROUTER_

/********************************************************************
 *																	*
 *	router types													*
 *	Written by Marco Kesseler										*
 *	february 1992													*
 *																	*
 *	Dep. of Mathematics and Computer Science						*
 *	University of Nijmegen											*
 *	Toernooiveld 1													*
 *	6525 ED Nijmegen												*
 *	The Netherlands													*
 *																	*
 ********************************************************************/

#ifndef _TYPES_
#include "types.h"
#endif

/********************************************************************************
 *																				*
 *		low level routing stuff													*
 *																				*
 ********************************************************************************/

#define NoRequest			(-1)
#define NoCancelReceived	(-2)

typedef struct PACKET_BUFFER_HEADER
{
	WORD	class;
	WORD	request;		/* used to piggy back requests. -1 means no request. */
	WORD	length;
	WORD	kind;
	WORD	destination;	/* in header to enable direct store... */
	
} PACKET_BUFFER_HEADER;

typedef struct VPACKET_BUFFER_BODY
{
	WORD	source;	
	BYTE	bytes[VariableArraySize];

} VPACKET_BUFFER_BODY;

typedef struct VPACKET_BUFFER{

	WORD							replicate;		/* used for broadcast routeing */
	struct PACKET_BUFFER_HEADER		header;
	struct VPACKET_BUFFER_BODY		body;

} VPACKET_BUFFER;

/********************************************************************************
 *																				*
 *		header and body as seen by higher levels								*
 *																				*
 ********************************************************************************/

#define buffer_header_address(buffer)	((VOID *)((ADDRESS)&(buffer)->header.length))
#define buffer_body_address(buffer)		((VOID *)((ADDRESS)&(buffer)->body.bytes))

/********************************************************************************
 *																				*
 *		exported routines														*
 *																				*
 ********************************************************************************/

extern BOOL initialise_router	(VOID);
extern BOOL start_router		(VOID);

extern BOOL start_virtual_link	(WORD linkno, VOID (*out) (VPACKET_BUFFER *), WORD out_stack_size, VOID (*in) (VPACKET_BUFFER *), WORD in_stack_size, BOOL (*test)(VOID));
extern VOID wake_virtual_link	(WORD linkno);

extern VOID kill_router			(VOID);

#endif
