#include "shell.h"

#include "commands.h"
#include "io.h"
#include "loader.h"
#include "debugger.h"

#ifdef __INCLUDE_STANDARD__

#endif

extern PROCESSOR_INFO	processor_info;

static VCOMMAND_TABLE	*command_table;

static VOID quit(VOID)
{
	hexit(0);
}

static VOID run(BOOL avail, CHAR *string)
{	
	if (!avail)
	{
		missing_string();
		return;
	}

	load_program(string,False);
	run_program();
}

static VOID debug(BOOL avail, CHAR *string)
{	
	if (!avail)
	{
		missing_string();
		return;
	}

	load_program(string,True);
	run_program();
}

static VOID load(BOOL avail, CHAR *string)
{	
	if (!avail)
	{
		missing_string();
		return;
	}

	load_program(string,False);
	
	file_print(StdErr,"loaded at %08X\n",processor_info.program_start);
}

extern VOID handle_debug_commands(VOID);

static COMMAND shell_commands[]=
{
	{"quit",		parse_e,			quit},
	{"run",			parse_ident,		run},
	{"debug",		parse_ident,		debug},
	{"load",		parse_ident,		load},
	{"x",			parse_e,			handle_debug_commands}
};

VOID shell (VOID)
{
	if (!(command_table=get_command_table(20)))
		return;
	
	if (!define_commands(command_table,shell_commands,sizeof(shell_commands)/sizeof(COMMAND)))
		return;
	
	execute_commands(command_table,"clean> ");
}