#ifndef _TYPES_
#define _TYPES_

/*
		file types.h
		author: Marco Kesseler
*/

#define __INCLUDE_STANDARD__
#define __NO_STACK_CHECKS__
#define	__CACHE_ROUTINES__		0		/* if true: cache routines in on-chip memory during runtime */

#ifdef __INCLUDE_STANDARD__

#include <limits.h>
#include <channel.h>

#endif

/********************************************************************************
 *																				*
 *		constants																*
 *																				*
 ********************************************************************************/

#define True  1
#define False 0

#define KiloByte		1024
#define MegaByte		(KiloByte*KiloByte)

/********************************************************************************
 *																				*
 *		basic types																*
 *																				*
 ********************************************************************************/

typedef	void			VOID;
typedef int				BOOL;
typedef	char			BYTE;
typedef	char			CHAR;
typedef unsigned char	UBYTE;
typedef unsigned char	UCHAR;
typedef int				WORD;
typedef unsigned int	UWORD;
typedef double			FLOAT;
typedef unsigned char*	ADDRESS;
typedef Channel 		CHANNEL;

typedef	struct ULWORD
{
	UWORD	lo;
	UWORD	hi;
	
} ULWORD;

typedef struct LWORD
{
	UWORD	lo;
	WORD	hi;
	
} LWORD;

typedef LWORD			TICKS;

/*	the label type allows to refer to assembly labels in a simple way,
	labels do not return some value */

typedef VOID (LABEL)();

typedef struct REMOTE_ADDRESS
{
	UWORD	weight:5, processor: 27;
	UWORD	id;
	
} REMOTE_ADDRESS;

#define MaxWeight 31

typedef struct REQUEST
{
	WORD			reserved;
	REMOTE_ADDRESS	address;
	
} REQUEST;

#define VariableArraySize	1

typedef struct VBYTE
{
	BYTE byte[VariableArraySize];
	
} VBYTE;

#if (VariableArraySize != 0)
#define vsizeof(s)				(sizeof(s)-sizeof(VBYTE))
#else
#define vsizeof(s)				(sizeof(s))
#endif

typedef struct VCLEAN_STRING
{
	WORD	length;
	CHAR	characters[VariableArraySize];
	
} VCLEAN_STRING;

#endif
